<?php
/**
 * @component Pay per Download Plus component
 * @author Ratmil Torres
 * @copyright (C) Ratmil Torres
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
// import the JPlugin class
jimport('joomla.event.plugin');

class plgPayperdownloadplusMenuitem extends JPlugin
{
	public function __construct(&$subject, $config = array())
    {
        parent::__construct($subject);
		// load the language file
		$lang = &JFactory::getLanguage();
		$lang->load('plg_payperdownloadplus_menuitem', JPATH_SITE.DS.'administrator');
	}

	function onIsActive(&$plugins)
	{
		jimport('joomla.filesystem.file');
		$image = "";
		$version = new JVersion;
		if($version->RELEASE == "1.5")
		{
			if(JFile::exists(JPATH_ROOT . DS . 'plugins' . DS . 'payperdownloadplus' . DS. 'menu.png'))
				$image = "plugins/payperdownloadplus/menu.png";
		}
		else
		{
			if(JFile::exists(JPATH_ROOT . DS . 'plugins' . DS . 'payperdownloadplus' . DS. 'menuitem' . DS . 'menu.png'))
				$image = "plugins/payperdownloadplus/menuitem/menu.png";
		}
		$plugins[] = array("name" => "Menuitem", "description" => JText::_("PAYPERDOWNLOADPLUS_MENUITEM_PLUGIN_JOOMLA_MENU_ITEM"), 
			"image" => $image);
	}
	
	
	function onRenderConfig($pluginName, $resource)
	{
		if($pluginName == "Menuitem")
		{
			if($resource)
			{
				$item_id = $resource->resource_id;
			}
			$items = $this->getMenuitems();
			$uri = JURI::root();
			?>
			<tr>
			<td  width="100" align="right" class="key"><?php echo htmlspecialchars(JText::_("PAYPERDOWNLOADPLUS_MENUITEM_PLUGIN_MENU_ITEM"));?></td>
			<td>
			<select id="menuitem" name="menuitem">
			<?php
			$last_menu_type = "";
			$group_open = false;
			foreach($items as $item)
			{
				if($item->menutype != $last_menu_type)
				{
					if($group_open)
						echo "</optgroup>";
					$group_open = true;
					echo "<optgroup label=\"" . htmlspecialchars($item->menutype) . "\">";
					$last_menu_type = $item->menutype;
				}
				$space = '';
				for($i = 0; $i < $item->depth; $i++)
					$space .= '&nbsp;&nbsp;&nbsp;&nbsp;';
				$selected = $item->id == $item_id ? "selected":"";
				echo "<option value=\"" . htmlspecialchars($item->id) . "\" $selected>" . 
					$space . htmlspecialchars($item->title) . "</option>";
			}
			if($group_open)
				echo "</optgroup>";
			?>
			</select>
			</td>
			</tr>
			<?php
		}
	}
	
	function reorderItems(&$items_ordered, $items, $parent_id, $depth)
	{
		$count = count($items);
		for($i = 0; $i < $count; $i++)
		{
			$item = $items[$i];
			if($item->parent_id == $parent_id)
			{
				$item->depth = $depth;
				$items_ordered[] = $item;
				$this->reorderItems($items_ordered, $items, $item->id, $depth + 1);
			}
		}
	}
	
	function getMenuitems()
	{
		$db =& JFactory::getDBO();
		$db->setQuery("SELECT config_id, payment_page_menuitem, thankyou_page_menuitem FROM #__payperdownloadplus_config", 0, 1);
		$menu_items = $db->loadObject();
		$version = new JVersion;
		if($version->RELEASE == "1.5")
			$query = "SELECT id, name as title, menutype, parent as parent_id FROM #__menu";
		else
			$query = "SELECT id, title, menutype, parent_id FROM #__menu WHERE client_id = 0";
		if($menu_items)
		{
			if(strpos($query, "WHERE") === false)
				$query .= " WHERE ";
			else
				$query .= " AND ";
			$query .= "id <> " . (int)$menu_items->payment_page_menuitem . 
				" AND id <> " . (int)$menu_items->thankyou_page_menuitem;
		}
		$query .= ' ORDER BY menutype';
		$db->setQuery($query);
		$items = $db->loadObjectList();
		$ordered_items = array();
		$this->reorderItems($ordered_items, $items, 0, 0);
		return $ordered_items;
	}
	
	function onGetSaveData(&$resourceId, 
		$pluginName, &$resourceName, &$resourceParams, &$optionParameter,
		&$resourceDesc)
	{
		if($pluginName == "Menuitem")
		{
			$optionParameter = "";
			$resourceId = JRequest::getInt('menuitem');
			$db =& JFactory::getDBO();
			$query = "";
			$resourceDesc = JText::_("PAYPERDOWNLOADPLUS_MENUITEM_PLUGIN_JOOMLA_MENU_ITEM");
			if($resourceId)
			{
				$query = "SELECT id, name FROM #__menu WHERE id = " . $resourceId;
			}
			$resourceName = JText::_("PAYPERDOWNLOADPLUS_MENUITEM_PLUGIN_JOOMLA_MENU_ITEM");
			if($query)
			{
				$db->setQuery( $query );
				$resource = $db->loadObject();
				if($resource)
					$resourceName = $resource->name;
			}
			
			$resourceParams = "";
		}
	}
		
	function onValidateAccess($option, $resources, &$allowAccess, &$requiredLicenses, &$resourcesId)
	{
		if(!is_array($requiredLicenses))
			$requiredLicenses = array();
		if(!is_array($resourcesId))
			$resourcesId = array();
		$itemid = JRequest::getInt('Itemid', 0);
		if($itemid == 0)
			return;
		foreach($resources as $resource)
		{
			if($resource->resource_id == $itemid)
			{
				if($resource->license_id)
				{
					if(array_search($resource->license_id, $requiredLicenses) === false)
						$requiredLicenses[] = $resource->license_id;
				}
				else
				{
					if(array_search($resource->resource_license_id, $resourcesId) === false)
						$resourcesId[] = $resource->resource_license_id;
				}
				$allowAccess = false;
			}
		}
	}
	
	
	function onAjaxCall($plugin, &$output)
	{
	}
	
	function getReturnPage($option, &$returnPage)
	{
		$itemid = JRequest::getInt('Itemid', 0);
		if($itemid == 0)
			return;
		$db =& JFactory::getDBO();
		$query = "SELECT resource_id FROM #__payperdownloadplus_resource_licenses 
			WHERE resource_option_parameter = '' AND resource_id = $itemid" ;
		$db->setQuery($query);
		$itemid = (int)$db->loadResult();
		if($itemid)
		{
			$query = "SELECT id, link FROM #__menu WHERE id = $itemid ";
			$db->setQuery($query);
			$menu = $db->loadObject();
			if($menu)
				$returnPage = $menu->link;
		}
	}
	
}
?>